--- source/gnu/crypto/jce/keyring/GnuKeyring.java~	2004-02-09 16:44:58.000000000 -0500
+++ source/gnu/crypto/jce/keyring/GnuKeyring.java	2005-12-24 15:02:13.000000000 -0500
@@ -83,9 +83,6 @@
    // Constants and fields.
    // ------------------------------------------------------------------------
 
-   private static final IllegalStateException NOT_LOADED =
-      new IllegalStateException("keyring not loaded");
-
    private boolean loaded;
    private IKeyring keyring;
 
@@ -100,7 +97,7 @@
 
    public Enumeration engineAliases() {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return new Enumeration() {
@@ -113,7 +110,7 @@
 
    public boolean engineContainsAlias(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return false;
@@ -123,7 +120,7 @@
 
    public void engineDeleteEntry(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring != null) {
          keyring.remove(alias);
@@ -132,7 +129,7 @@
 
    public Certificate engineGetCertificate(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return null;
@@ -145,7 +142,7 @@
 
    public String engineGetCertificateAlias(Certificate cert) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return null;
@@ -166,7 +163,7 @@
 
    public void engineSetCertificateEntry(String alias, Certificate cert) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          keyring = new GnuPublicKeyring("HMAC-SHA-1", 20);
@@ -179,7 +176,7 @@
 
    public Certificate[] engineGetCertificateChain(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return null;
@@ -192,7 +189,7 @@
 
    public Date engineGetCreationDate(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return null;
@@ -214,7 +211,7 @@
       throws UnrecoverableKeyException
    {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return null;
@@ -238,7 +235,7 @@
       throws KeyStoreException
    {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          keyring = new GnuPrivateKeyring("HMAC-SHA-1", 20, "AES", "OFB", 16);
@@ -271,7 +268,7 @@
 
    public boolean engineIsCertificateEntry(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return false;
@@ -284,7 +281,7 @@
 
    public boolean engineIsKeyEntry(String alias) {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return false;
@@ -331,7 +328,7 @@
       throws IOException
    {
       if (!loaded || keyring == null) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       HashMap attr = new HashMap();
       attr.put(IKeyring.KEYRING_DATA_OUT, out);
@@ -341,7 +338,7 @@
 
    public int engineSize() {
       if (!loaded) {
-         throw NOT_LOADED;
+         throw new IllegalStateException("keyring not loaded");
       }
       if (keyring == null) {
          return 0;